actions/urls.py
from django.urls import path

from . import views


app_name = 'actions'
urlpatterns = [
    path('', views.NotificationList.as_view(), name='notification_list')
]

apiv1/urls.py
from django.urls import path, include

from rest_framework.urlpatterns import format_suffix_patterns
from rest_framework.routers import DefaultRouter

from . import viewsets

router = DefaultRouter()
router.register(r'events', viewsets.EventViewset)
router.register(r'comments', viewsets.CommentViewset)
router.register(r'category', viewsets.CategoryViewset)
router.register(r'profile', viewsets.ProfileViewset)

app_name = 'apiv1'
urlpatterns = [
    path('', include(router.urls))
]

comments/urls.py
from django.urls import path
from . import views


app_name = 'comments'
urlpatterns = [
    path('<int:pk>/delete/', views.CommentDelete.as_view(), name='comment-delete'),
    path('<comment_id>/<event_id>/detail/', views.comment_detail, name='comment-detail'),

]

events/urls.py
from django.urls import path
from . import views

app_name = 'events'
urlpatterns = [
    path('', views.EventList.as_view(), name='event-list'),
    path('events/<int:pk>/', views.EventDetail.as_view(), name='event-detail'),
    path('events/new/', views.EventCreate.as_view(), name='event-create' ),
    path('events/<int:pk>/delete', views.EventDelete.as_view(), name='event-delete'),
    path('events/<int:pk>/update', views.EventUpdate.as_view(), name='event-update'),
    path('events/<event_id>/attend/', views.attend_event, name='attend_event'),
    path('events/<event_id>/not_attend/', views.not_attend_event, name='not_attend_event'),

]

meethub/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from filebrowser.sites import site

# from . import settings


urlpatterns = [
    path('iyanuashiri/', admin.site.urls),
    path('iyanuashiri/filebrowser/', site.urls),
    path('', include('events.urls'), name='events'),
    path('accounts/', include('accounts.urls')),
    path('tinymce/', include('tinymce.urls')),
    path('userprofile/', include('userprofile.urls'), name='userprofile'),
    path('notifications/', include('actions.urls')),
    path('comments/', include('comments.urls')),

    path('api/v1/', include('apiv1.urls')),

]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

userprofile/urls.py
from django.urls import path


from . import views


app_name = 'userprofile'
urlpatterns = [
    path('edit/', views.edit_profile, name='edit'),
    path('detail/<int:pk>/', views.UserDetail.as_view(), name='detail'),
]

events/models.py
from django.db import models
from django.conf import settings
from django.shortcuts import reverse
from django.contrib.auth.models import User

from tinymce import HTMLField


# Create your models here.


class Category(models.Model):
    name = models.CharField(max_length=50, unique=True)
    description = models.TextField(max_length=500)

    class Meta:
        verbose_name = 'category'
        verbose_name_plural = 'categories'

    def __str__(self):
        return self.name


class Event(models.Model):
    name = models.CharField(max_length=50)
    details = HTMLField('Details')
    venue = models.CharField(max_length=200)
    date = models.DateField(help_text='Please use the following format: <em>YYYY-MM-DD</em>.')
    time = models.TimeField(help_text='Please use the following format: <em>HH:MM:SS<em>')
    category = models.ForeignKey(Category, on_delete=models.CASCADE, related_name='events')
    creator = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    attendees = models.ManyToManyField(settings.AUTH_USER_MODEL, related_name='attending', blank=True)
    num_of_attendees = models.PositiveIntegerField(default=0, blank=True)

    class Meta:
        verbose_name = 'event'
        verbose_name_plural = 'events'
        ordering = ['date', 'time']

    def get_absolute_url(self):
        return reverse('events:event-detail', kwargs={'pk': self.pk})

    def __str__(self):
        return self.name

    def get_number_of_attendees(self):
        return self.attendees.all().count()

    def get_comments_number(self):
        return self.comments.all().count()

events/forms.py
from django import forms

from tinymce import TinyMCE

from .models import Event


class TinyMCEWidget(TinyMCE):
    def use_required_attribute(self, *args):
        return False


class EventForm(forms.ModelForm):
    details = forms.CharField(
        widget=TinyMCEWidget(
            attrs={'required':False, 'cols':30, 'rows':10}
        )
    )

    class Meta:
        model = Event
        fields = ('category', 'name', 'details', 'venue', 'time', 'date',)

events/views.py
from django.views import generic
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import get_object_or_404, redirect
from django.contrib import messages
from django.contrib.messages.views import SuccessMessageMixin
from django.contrib.auth.models import User
from django.views import View
from django.contrib.auth.decorators import login_required

from actions.utils import create_action
from comments.models import Comment
from comments.forms import CommentForm

from .models import Event


# Create your views here.


class EventList(LoginRequiredMixin, generic.ListView):
    model = Event
    template_name = 'events/list_of_events.html'
    context_object_name = 'events'
    paginate_by = 10

    def get_queryset(self):
        if self.request.user.is_superuser:
            return Event.objects.all()
        else:
            return Event.objects.all()


class EventDisplay(generic.DetailView):
    model = Event
    template_name = 'events/detail.html'
    context_object_name = 'event'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['form'] = CommentForm()
        context['comments'] = self.get_object().comments.all()
        context['attending'] = self.get_object().attendees.all
        return context


class CommentCreate(SuccessMessageMixin, generic.CreateView):
    model = Comment
    template_name = 'events/detail.html'
    fields = ('comment',)
    success_message = 'Comment was added successfully'

    def form_valid(self, form):
        form.instance = form.save(commit=False)
        form.instance.event = self.get_object(queryset=Event.objects.all())
        form.instance.created_by = self.request.user
        create_action(self.request.user, 'added a comment', form.instance)
        form.save()
        return super().form_valid(form)

    def get_success_url(self):
        return reverse_lazy('events:event-detail', kwargs={'pk': self.get_object(Event.objects.all()).pk})


class EventDetail(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        view = EventDisplay.as_view()
        return view(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        view = CommentCreate.as_view()
        return view(request, *args, **kwargs)


class EventFormMixin(object):
    def form_valid(self, form):
        form.instance.creator = self.request.user
        create_action(self.request.user, 'created a new event', form.instance)
        return super().form_valid(form)


class EventCreate(LoginRequiredMixin, SuccessMessageMixin, EventFormMixin, generic.CreateView):
    model = Event
    template_name = 'events/create_form.html'
    fields = ('category', 'name', 'details', 'venue', 'time', 'date')
    context_object_name = 'event'
    success_message = "%(name)s was created successfully"


class EventUpdate(LoginRequiredMixin, SuccessMessageMixin, EventFormMixin, generic.UpdateView):
    model = Event
    template_name = 'events/update_form.html'
    template_name_suffix = '_update_form'
    fields = ('category', 'name', 'details', 'venue', 'time', 'date',)
    success_message = "%(name)s was updated successfully"


class EventDelete(LoginRequiredMixin, SuccessMessageMixin, generic.DeleteView):
    model = Event
    template_name = 'events/delete.html'
    success_url = reverse_lazy('events:event-list')
    context_object_name = 'event'
    success_message = "%(name)s was deleted successfully"


@login_required()
def attend_event(request, event_id):
    event = get_object_or_404(Event, pk=event_id)
    attendee = User.objects.get(username=request.user)
    event.attendees.add(attendee)
    create_action(attendee, 'is attending', event)
    messages.success(request, 'You are now attending {0}'.format(event.name))
    return redirect('events:event-detail', pk=event.pk)


@login_required()
def not_attend_event(request, event_id):
    event = get_object_or_404(Event, pk=event_id)
    attendee = User.objects.get(username=request.user)
    event.attendees.remove(attendee)
    create_action(attendee, 'no longer attending', event)
    messages.success(request, 'You are no longer attending {0}'.format(event.name))
    return redirect('events:event-detail', pk=event.pk)

events/templates/events/base.html
<!DOCTYPE html>
{% load staticfiles %}
{% load events_tags %}
{% load crispy_forms_tags %}
{% load crispy_forms_filters %}

<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.0/css/bootstrap.min.css" integrity="sha384-9gVQ4dYFwwWSjIDZnLEWnxCjeSWFphJiwGPXr1jddIhOegiu1FwO5qRGvFXOdJZ4" crossorigin="anonymous">

    <title>Find Your Events</title>
</head>
<body>

    <nav class="navbar navbar-expand-lg navbar-light bg-info sticky-top">
        <a class="navbar-brand" href="#"><h1>MeetHub</h1></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="{% url 'events:event-list' %}">Explore<span class="sr-only">(current)</span></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'events:event-create' %}">Create a new Event</a>
                </li>

                <li class="nav-item">
                    <a class="nav-link" href="{% url 'actions:notification_list' %}">Notifications</a>

                </li>

                <li class="nav-item">
                    <a class="nav-link" href="{% url 'userprofile:detail' user.id %}">Profile</a>
                </li>
            </ul>
            {% comment %}
            <form class="form-inline my-2 my-lg-0">
                <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
                <button class="btn btn-outline-light my-2 my-sm-0" type="submit">Search</button>
            </form>
            {% endcomment %}
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                </li>


                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        {{ user }}

                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="#">Action</a>
                        <a class="dropdown-item" href="#">Another action</a>
                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="#">Something else here</a>
                    </div>
                </li>
            </ul>

        </div>
    </nav>


    <div>
        {% if messages %}
        <ul class="alert alert-success alert-dismissible fade show w-75 mx-auto">
            {% for message in messages %}
            <li {% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>

            {% endfor %}


        </ul>

        {% endif %}
    </div>

    {% block content %}

    {% endblock %}

    <script type="text/javascript" src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.0/umd/popper.min.js" integrity="sha384-cs/chFZiN24E4KMATLdqdvsezGxaGsi4hLGOzlXwp5UZB1LY//20VyM2taTB4QvJ" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.0/js/bootstrap.min.js" integrity="sha384-uefMccjFJAIv6A+rW+L4AHf99KvxDjWSu1z9VI8SKNVmz4sk7buKt/6v9KI65qnm" crossorigin="anonymous"></script>
    <script src="{% static 'javascript/main.js' %}"></script>

</body>
</html>

events/templates/events/comment_reply.html
{% extends 'events/base.html' %}
{% load crispy_forms_filters %}
    {% block content %}
        <div class="mx-auto w-100">
      <form class="mx-auto w-50" method="post"> {% csrf_token %}
        {{ form|crispy }}
        <button class="mx-auto btn btn-primary btn-lg active w-25" type="submit">Add comment</button>
      </form>


    </div>

    {% endblock %}

events/templates/events/create_form.html
{% extends 'events/base.html' %}
{% load static %}
{% load crispy_forms_filters %}


  {% block content %}
      {{ form.media }}
      <div class="mx-auto w-75">
          <h1>Congratulations, You want to create an event</h1>
          <form method="post" > {% csrf_token %}
            {{ form|crispy }}
            <button class="mx-auto btn btn-primary btn active w-25" type="submit"> Create</button>
          </form>
      </div>


  {% endblock %}

events/templates/events/delete.html
{% extends 'events/base.html' %}
  {% block content %}
      <div class="jumbotron">
      <div class="mx-auto w-50 shadow-sm">
          <form action="" method="post">{% csrf_token %}
            <p>Are you sure you want to delete "{{ event }}"?</p>
            <input class="mx-auto btn btn-danger btn active w-25" type="submit" value="Confirm" />
          </form>
      </div>
      </div>
  {% endblock %}

events/templates/events/detail.html
{% extends 'events/base.html' %}
{% load events_tags %}
{% load events_filters %}
{% load crispy_forms_filters %}
{% load cloudinary %}


  {% block content %}
      <div class="card">
        <div class="card-body">
            <h3 class="card-text"><small>Organizer: {{ event.creator|capfirst }}</small></h3>
            <h1 class="card-text">{{ event.name }}</h1>
            <h3 class="card-text text-muted float-left">{{ event.date }}; </h3>

            <h3 class="card-text text-muted">{{ event.time }}</h3>
            {% if request.user in attending %}
                <a class="btn btn-danger btn active w-25" href="{% url 'events:not_attend_event' event.id %}">Not Attending</a>
            {% else %}
                <a class="btn btn-success btn active w-25" href="{% url 'events:attend_event' event.id %}">Attend</a>

            {% endif %}
        </div>
      </div>

      <div class="jumbotron w-75 mx-auto">
        <h1 class="display-4">Details</h1>
        <p class="lead">{{ event.details|safe }}</p>
      </div>



    <div class="mx-auto w-75">
        <h2>{{ event.get_number_of_attendees }} Attending</h2>
            <div class="card card-body">
                {% for attendee in attending %}
                    <p>{{ attendee.username|capfirst }}</p>

                {% endfor %}

            </div>
        </div>
    </div>

    <div>
        <h2 class="w-75 mx-auto">{{ event.get_comments_number }} Comments</h2>
      {% for comment in comments %}
          {% if not comment.get_parents %}

              <div class="media card w-75 mx-auto border-dark">
                <div class="media-body card-body">
                    <h4 class="card-text">{% cloudinary comment.get_comment_creator_photo width=45 height=45 radius='max' crop='fill' %}{{ comment.created_by }}</h4>
                    <p class="card-text">{{ comment.comment }}</p>
                    <a href="{% url 'comments:comment-detail' comment.id event.id %}">Reply</a>

                    {% if comment.get_children %}

                    <div class="media card mx-auto">
                        <div class="media-body card-body">
                            {% for child in comment.get_children %}
                                <h4 class="card-text">{% cloudinary child.get_comment_creator_photo width=45 height=45 radius='max' crop='fill' %}{{ child.created_by }}</h4>
                                <p class="card-text">{{ child.comment }}</p>
                                <a href="{% url 'comments:comment-detail' child.id event.id %}">Reply</a>

                                {% if child.get_children %}

                                <div class="media card mx-auto">
                                    <div class="media-body card-body">
                                        {% for grandchild in child.get_children %}
                                            <h4 class="card-text">{% cloudinary comment.get_comment_creator_photo width=45 height=45 radius='max' crop='fill' %}{{ grandchild.created_by }}</h4>
                                            <p class="card-text">{{ grandchild.comment }}</p>
                                        {% endfor %}

                                    </div>
                                </div>
                                {% else %}
                                {% endif %}
                            {% endfor %}
                        </div>
                    {% else %}
                    {% endif %}
                    </div>
                </div>
              </div>
              <br>
          {% endif %}


      {%  endfor %}

    </div>

    <div>

    </div>

    <div class="mx-auto w-100">
      <form class="mx-auto w-50" method="post"> {% csrf_token %}
        {{ form|crispy }}
        <button class="mx-auto btn btn-primary btn-lg active w-25" type="submit">Add comment</button>
      </form>


    </div>

  {% endblock %}

events/templates/events/list_of_events.html
{% extends 'events/base.html' %}
{% load events_filters %}

    {% block content %}
        {% for event in events %}
            <p class="mx-auto w-75"><strong>{{ event.date }}</strong></p>
            <div class="card w-75 mx-auto border-info">
                <div class="card-body">
                    <div>
                        <p class="card-text"><strong>{{ event.venue|upper }}</strong> - <small class="text-muted">{{ event.time }}</small></p>
                        <h2><a class="card-text text-info" href="{% url 'events:event-detail' event.id %}">{{event.name}}</a></h2>
                        <p>{{event.details|safe|truncatewords_html:25}}</p>
                        <span class="card-text"><strong>{{ event.get_number_of_attendees }}</strong> Attending</span>
                    </div>


                </div>
            </div>
        {% endfor %}


    {% endblock %}

events/templates/events/update_form.html
{% extends 'events/base.html' %}
{% load static %}
{% load crispy_forms_filters %}

  {% block content %}
      {{ form.media }}
      <div class="jumbotron">
      <div class="mx-auto w-75">
        <form method="post">{% csrf_token %}
            {{ form|crispy }}
            <input class="mx-auto btn btn-primary btn active w-25" type="submit" value="Update" />
        </form>
      </div>
      </div>
  {% endblock %}